unit reMainForm;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SynEdit, StdCtrls, Buttons, ComCtrls, Menus,
  ClipBrd;

type
  TOptionGener = (opCode, opPreview);

type
  TMainForm = class(TForm)
    SynEdit1: TSynEdit;
    MainMenu1: TMainMenu;
    MenuClose: TMenuItem;
    PageControl1: TPageControl;
    TBMessageDlg: TTabSheet;
    MsgDlg_RichEdit1: TRichEdit;
    LabelMessageDlgText: TLabel;
    GB_MsgDlg_ReturnValue: TGroupBox;
    CB_MsgDlg_Btn_mrAbort: TCheckBox;
    CB_MsgDlg_Btn_mrCancel: TCheckBox;
    CB_MsgDlg_Btn_mrIgnore: TCheckBox;
    CB_MsgDlg_Btn_mrNo: TCheckBox;
    CB_MsgDlg_Btn_mrOK: TCheckBox;
    CB_MsgDlg_Btn_mrYes: TCheckBox;
    CB_MsgDlg_Btn_mrYesToAll: TCheckBox;
    CB_MsgDlg_Btn_mrRetry: TCheckBox;
    CB_MsgDlg_Btn_mrAll: TCheckBox;
    CB_MsgDlg_Btn_mrNoToAll: TCheckBox;
    GB_MsgDlg_Buttons: TGroupBox;
    CB_MsgDlg_Btn_mbAbort: TCheckBox;
    CB_MsgDlg_Btn_mbHelp: TCheckBox;
    CB_MsgDlg_Btn_mbCancel: TCheckBox;
    CB_MsgDlg_Btn_mbIgnore: TCheckBox;
    CB_MsgDlg_Btn_mbNo: TCheckBox;
    CB_MsgDlg_Btn_mbOK: TCheckBox;
    CB_MsgDlg_Btn_mbYes: TCheckBox;
    CB_MsgDlg_Btn_mbYesToAll: TCheckBox;
    CB_MsgDlg_Btn_mbRetry: TCheckBox;
    CB_MsgDlg_Btn_mbAll: TCheckBox;
    CB_MsgDlg_Btn_mbNoToAll: TCheckBox;
    Edit_MsgDlg_HelpContext: TEdit;
    Label1: TLabel;
    CB_MsgDlg_PredefinedTypes: TComboBox;
    Label_MsgDlg_PredefinedTypes: TLabel;
    RB_MsgDlg_Message: TRadioButton;
    RB_MsgDlg_MessageThen: TRadioButton;
    RB_MsgDlg_MessageCase: TRadioButton;
    MenuAbout: TMenuItem;
    CB_MsgDlg_BreakLines: TCheckBox;
    Button_MsgDlg_Start: TBitBtn;
    Button_MsgDlg_CopyToClipboard: TBitBtn;
    Button_MsgDlg_Preview: TBitBtn;
    //***** Routines *****
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ShowFormAbout;
    procedure MenuAboutClick(Sender: TObject);
    //***** Tab MsgDlg *****
    procedure MsgDlg_EditOnlyNums(Sender: TObject; var Key: Char);
    procedure Button_MsgDlg_CopyToClipboardClick(Sender: TObject);
    function MsgDlg_IsUserReady: Byte;
    procedure MsgDlg_MessageUserNotReady;
    function IsMsgDlgButtonsChecked: Boolean;
    function IsMsgDlgReturnValueChecked: Boolean;
    function MsgDlg_GetText(aOptionGener: TOptionGener): String;
    function MsgDlg_GetButtonsStr: String;
    function MsgDlg_GetReturnValueStr: String;
    function MsgDlg_GetDlgTypeStr: String;
    procedure Button_MsgDlg_StartClick(Sender: TObject);
    function MsgDlg_Start: Boolean;
    function MsgDlg_DoMessage: Boolean;
    function MsgDlg_DoMessageThen: Boolean;
    function MsgDlg_DoMessageCase: Boolean;
    procedure Button_MsgDlg_PreviewClick(Sender: TObject);
    //***** Place for other tabs if wanted *****

  private
    { Dclarations prives }

  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;

implementation
 uses reFormAbout;

{$R *.dfm}

//***** Routines **************************************************************
procedure TMainForm.FormCreate(Sender: TObject);
begin
  CB_MsgDlg_PredefinedTypes.ItemIndex := 3;
  CB_MsgDlg_PredefinedTypes.DropDownCount := CB_MsgDlg_PredefinedTypes.Items.Count;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
//
end;

procedure TMainForm.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ShowFormAbout;
begin
 with TFormAbout.Create(Self) do
   try
     ShowModal;
   finally
     Free;
   end;
end;

procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
  ShowFormAbout;
end;

//***** Tab MsgDlg ************************************************************
procedure TMainForm.MsgDlg_EditOnlyNums(Sender: TObject; var Key: Char);
begin
 if not (Key in [#8,{#13,}'0'..'9']) then Key:=#9;
end;

procedure TMainForm.Button_MsgDlg_CopyToClipboardClick(Sender: TObject);
begin
  Clipboard.AsText := SynEdit1.Text;
end;

function TMainForm.MsgDlg_IsUserReady: Byte;
begin
//Returns 0 if nothing ready, 1 if text OK, 2 if Text & Buttons OK,
//3 if Text & return value OK, 4 if all is OK
 Result := 0;
 if (MsgDlg_RichEdit1.Text <> '') and (IsMsgDlgButtonsChecked) and (IsMsgDlgReturnValueChecked)
   then begin Result := 4; Exit; end;
 if (MsgDlg_RichEdit1.Text <> '') then begin
   Result := 1;
   if (IsMsgDlgButtonsChecked) then Result := 2;
   if (IsMsgDlgReturnValueChecked) then Result := 3;
 end;
end;

procedure TMainForm.MsgDlg_MessageUserNotReady;
begin
  MessageDlg('You have not entered all the necessary data.', mtInformation, [mbOk], 0);
end;

function TMainForm.IsMsgDlgButtonsChecked: Boolean;
begin
//Checking
  Result := False;
  if CB_MsgDlg_Btn_mbOK.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbCancel.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbAbort.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbIgnore.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbRetry.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbHelp.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbYes.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbNo.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbYesToAll.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbNoToAll.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mbAll.Checked then begin Result := True; Exit; end;
end;

function TMainForm.IsMsgDlgReturnValueChecked: Boolean;
begin
//Checking
  Result := False;
  if CB_MsgDlg_Btn_mrOK.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrCancel.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrAbort.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrIgnore.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrRetry.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrYes.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrNo.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrYesToAll.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrNoToAll.Checked then begin Result := True; Exit; end;
  if CB_MsgDlg_Btn_mrAll.Checked then begin Result := True; Exit; end;
end;

function TMainForm.MsgDlg_GetText(aOptionGener: TOptionGener): String;
var
  aText, aReplacement : String;
begin
//Returns text with line breaks if CB_MsgDlg_BreakLines is checked
  aText := Trim(MsgDlg_RichEdit1.Text);
  case CB_MsgDlg_BreakLines.Checked of
    True : begin
             if aOptionGener = opCode
               then aReplacement := ''' + #13#10 + ''' //For code
               else aReplacement := '' + #13#10 + '';  //For preview
               Result := StringReplace(aText, #13#10, aReplacement, [rfReplaceAll]);
           end;
    False : Result := StringReplace(aText, #13#10, '', [rfReplaceAll]);
  end;//End case...
end;

function TMainForm.MsgDlg_GetButtonsStr: String;
var
  S : String;
begin
  if CB_MsgDlg_Btn_mbOK.Checked then S := 'mbOk,';
  if CB_MsgDlg_Btn_mbCancel.Checked then S := S + 'mbCancel,';
  if CB_MsgDlg_Btn_mbAbort.Checked then S := S + 'mbAbort,';
  if CB_MsgDlg_Btn_mbIgnore.Checked then S := S + 'mbIgnore,';
  if CB_MsgDlg_Btn_mbRetry.Checked then S := S + 'mbRetry,';
  if CB_MsgDlg_Btn_mbHelp.Checked then S := S + 'mbHelp,';
  if CB_MsgDlg_Btn_mbYes.Checked then S := S + 'mbYes,';
  if CB_MsgDlg_Btn_mbNo.Checked then S := S + 'mbNo,';
  if CB_MsgDlg_Btn_mbYesToAll.Checked then S := S + 'mbYesToAll,';
  if CB_MsgDlg_Btn_mbNoToAll.Checked then S := S + 'mbNoToAll,';
  if CB_MsgDlg_Btn_mbAll.Checked then S := S + 'mbAll,';
  Delete(S, Length(S), 1);
  Result := S;
end;

function TMainForm.MsgDlg_GetReturnValueStr: String;
var
  S : String;
begin
  if CB_MsgDlg_Btn_mrOK.Checked then S := 'mrOk';
  if CB_MsgDlg_Btn_mrCancel.Checked then S := 'mrCancel';
  if CB_MsgDlg_Btn_mrAbort.Checked then S := 'mrAbort';
  if CB_MsgDlg_Btn_mrIgnore.Checked then S := 'mrIgnore';
  if CB_MsgDlg_Btn_mrRetry.Checked then S := 'mrRetry';
  if CB_MsgDlg_Btn_mrYes.Checked then S := 'mrYes';
  if CB_MsgDlg_Btn_mrNo.Checked then S := 'mrNo';
  if CB_MsgDlg_Btn_mrYesToAll.Checked then S := 'mrYesToAll';
  if CB_MsgDlg_Btn_mrNoToAll.Checked then S := 'mrNoToAll';
  if CB_MsgDlg_Btn_mrAll.Checked then S := 'mrAll';
  Result := S;
end;

function TMainForm.MsgDlg_GetDlgTypeStr: String;
begin
  Result := 'mtInformation';
  case CB_MsgDlg_PredefinedTypes.ItemIndex of
    0 : Result := 'mtWarning';
    1 : Result := 'mtError';
    2 : Result := 'mtConfirmation';
    3 : Result := 'mtInformation';
    4 : Result := 'mtCustom;'
  end;
end;

procedure TMainForm.Button_MsgDlg_StartClick(Sender: TObject);
begin
  MsgDlg_Start;
end;

function TMainForm.MsgDlg_Start: Boolean;
begin
  SynEdit1.Lines.Clear;
  Result := False;
  if RB_MsgDlg_Message.Checked then Result := MsgDlg_DoMessage;
  if RB_MsgDlg_MessageThen.Checked then Result := MsgDlg_DoMessageThen;
  if RB_MsgDlg_MessageCase.Checked then Result := MsgDlg_DoMessageCase;
end;

function TMainForm.MsgDlg_DoMessage: Boolean;
var
  S, aButtons, aText, aDlgType, aHelpContext : String;
begin
  Result := False;
  if MsgDlg_IsUserReady < 1 then begin MsgDlg_MessageUserNotReady; Exit; end;
  aButtons := MsgDlg_GetButtonsStr;
  aText := MsgDlg_GetText(opCode);
  aDlgType := MsgDlg_GetDlgTypeStr;
  aHelpContext := Edit_MsgDlg_HelpContext.Text;
  S := Format('MessageDlg(''%s'',' + #13#10 +
              '  %s, [%s], %s);',
              [aText,
               aDlgType, aButtons, aHelpContext]);
  SynEdit1.Text := S;
  Result := True;
end;

function TMainForm.MsgDlg_DoMessageThen: Boolean;
var
  S, aButtons, aReturnValue, aText, aDlgType, aHelpContext : String;
begin
  Result := False;
  if MsgDlg_IsUserReady < 4 then begin MsgDlg_MessageUserNotReady; Exit; end;
  aButtons := MsgDlg_GetButtonsStr;
  aReturnValue := MsgDlg_GetReturnValueStr;
  aText := MsgDlg_GetText(opCode);
  aDlgType := MsgDlg_GetDlgTypeStr;
  aHelpContext := Edit_MsgDlg_HelpContext.Text;
  S := Format('if MessageDlg(''%s'',' + #13#10 +
              '   %s, [%s], %s) = %s ' + #13#10 +
              '   then',
              [aText,
               aDlgType, aButtons, aHelpContext, aReturnValue]);
  SynEdit1.Text := S;
  Result := True;
end;

function TMainForm.MsgDlg_DoMessageCase: Boolean;
var
  S, aButtons, aText, aDlgType, aHelpContext : String;
begin
  Result := False;
  if MsgDlg_IsUserReady < 4 then begin MsgDlg_MessageUserNotReady; Exit; end;
  aButtons := MsgDlg_GetButtonsStr;
  aText := MsgDlg_GetText(opCode);
  aDlgType := MsgDlg_GetDlgTypeStr;
  aHelpContext := Edit_MsgDlg_HelpContext.Text;
  S := Format('case MessageDlg(''%s'',' + #13#10 +
              '     %s, [%s], %s) of' + #13#10,
              [aText,
               aDlgType, aButtons, aHelpContext]);
  if CB_MsgDlg_Btn_mrOK.Checked then S := S + '  mrOk: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrCancel.Checked then S := S + '  mrCancel: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrAbort.Checked then S := S + '  mrAbort: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrIgnore.Checked then S := S + '  mrIgnore: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrRetry.Checked then S := S + '  mrRetry: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrYes.Checked then S := S + '  mrYes: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrNo.Checked then S := S + '  mrNo: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrYesToAll.Checked then S := S + '  mrYesToAll: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrNoToAll.Checked then S := S + '  mrNoToAll: ;' + #13#10 ;
  if CB_MsgDlg_Btn_mrAll.Checked then S := S + '  mrAll: ;' + #13#10 ;
  S := S + 'end;';
  SynEdit1.Text := S;
  Result := True;
end;

procedure TMainForm.Button_MsgDlg_PreviewClick(Sender: TObject);

  function _GetDlgType: TMsgDlgType;
  begin
    Result := mtInformation;
    case CB_MsgDlg_PredefinedTypes.ItemIndex of
      0 : Result := mtWarning;
      1 : Result := mtError;
      2 : Result := mtConfirmation;
      3 : Result := mtInformation;
      4 : Result := mtCustom;
    end;
  end;

  function _GetDlgButtons(aDlgButtons: TMsgDlgButtons): TMsgDlgButtons;
  begin
    aDlgButtons := aDlgButtons - [mbOK,mbCancel,mbAbort,mbIgnore,mbRetry,mbYes,mbNo,mbYesToAll,mbNoToAll,mbAll,mbHelp];
    if CB_MsgDlg_Btn_mbOK.Checked then aDlgButtons := aDlgButtons + [mbOK];
    if CB_MsgDlg_Btn_mbCancel.Checked then aDlgButtons := aDlgButtons + [mbCancel];
    if CB_MsgDlg_Btn_mbAbort.Checked then aDlgButtons := aDlgButtons + [mbAbort];
    if CB_MsgDlg_Btn_mbIgnore.Checked then aDlgButtons := aDlgButtons + [mbIgnore];
    if CB_MsgDlg_Btn_mbRetry.Checked then aDlgButtons := aDlgButtons + [mbRetry];
    if CB_MsgDlg_Btn_mbYes.Checked then aDlgButtons := aDlgButtons + [mbYes];
    if CB_MsgDlg_Btn_mbNo.Checked then aDlgButtons := aDlgButtons + [mbNo];
    if CB_MsgDlg_Btn_mbYesToAll.Checked then aDlgButtons := aDlgButtons + [mbYesToAll];
    if CB_MsgDlg_Btn_mbNoToAll.Checked then aDlgButtons := aDlgButtons + [mbNoToAll];
    if CB_MsgDlg_Btn_mbAll.Checked then aDlgButtons := aDlgButtons + [mbAll];
    if CB_MsgDlg_Btn_mbHelp.Checked then aDlgButtons := aDlgButtons + [mbHelp];
    Result := aDlgButtons;
  end;

var
  aText : String;
  aDlgType : TMsgDlgType;
  aDlgButtons : TMsgDlgButtons;
  aHelpContext : Integer;
begin
  if MsgDlg_Start then begin
    aText := MsgDlg_GetText(opPreview);
    aDlgType := _GetDlgType;
    aDlgButtons := _GetDlgButtons(aDlgButtons);
    aHelpContext := StrToInt(Edit_MsgDlg_HelpContext.Text);
    //----- MessageDlg -----
    MessageDlg(aText, aDlgType, aDlgButtons, aHelpContext);
  end;
end;

//***** Place for other tabs if wanted *****

end.
